/*$Id: d_coment.cc,v 26.14 2007/02/07 09:06:48 al Exp $ -*- C++ -*-
 * Copyright (C) 2001 Albert Davis
 * Author: Albert Davis <aldavis@ieee.org>
 *
 * This file is part of "Gnucap", the Gnu Circuit Analysis Package
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *------------------------------------------------------------------
 * processing for COMMENT netlist item (pseudo-device)
 */
//testing=script,complete 2006.07.17
#include "l_dispatcher.h"
#include "e_card.h"
extern DISPATCHER<CARD> device_dispatcher;
/*--------------------------------------------------------------------------*/
namespace {
/*--------------------------------------------------------------------------*/
class DEV_COMMENT : public CARD {
private:
  std::string	_s;
  explicit	DEV_COMMENT(const DEV_COMMENT& p)
				:CARD(p) {set_constant(true);}
public:
  explicit	DEV_COMMENT()	:CARD()  {set_constant(true);}
private: // override virtual
  char		id_letter()const	{untested();return '\0';}
  const char*	dev_type()const	{untested(); return "comment";}
  CARD*		clone()const	{return new DEV_COMMENT(*this);}
  void		parse_spice(CS& cmd)	{_s = cmd.fullstring();}
  void		print(OMSTREAM&, LANGUAGE)const;
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
void DEV_COMMENT::print(OMSTREAM& o, LANGUAGE lang)const
{
  assert(lang == lSPICE || lang == lVERILOG);
  if (_s[0] != '*'  ||  _s[1] != '+') {
    o << _s << '\n';
  }else{
  }
  // Suppress printing of comment lines starting with "*+".
  // These are generated as a way to display calculated values.
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
DEV_COMMENT p1;
DISPATCHER<CARD>::INSTALL
  d1(&device_dispatcher, ";,#,*,',\",dev_comment", &p1);
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
