/*$Id: u_lang.cc,v 26.1 2006/09/12 07:11:18 al Exp $ -*- C++ -*-
 * Copyright (C) 2006 Albert Davis
 * Author: Albert Davis <aldavis@ieee.org>
 *
 * This file is part of "Gnucap", the Gnu Circuit Analysis Package
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
#include "u_lang.h"
/*--------------------------------------------------------------------------*/
static int arg_list_is_open = 0;

void print_open_arg_list(OMSTREAM& o, LANGUAGE lang)
{
  assert(!arg_list_is_open);
  ++arg_list_is_open;
  assert(arg_list_is_open);

  switch (lang) {
  case lACS:
  case lSPICE:
    o << ' ';
    break;
  case lVERILOG:
    o << " #(";
    break;
  case lAUTO:
    unreachable();
  }
}

void print_close_arg_list(OMSTREAM& o, LANGUAGE lang)
{
  assert(arg_list_is_open);
  --arg_list_is_open;
  assert(!arg_list_is_open);

  switch (lang) {
  case lACS:
  case lSPICE:
    // nothing
    break;
  case lVERILOG:
    o << ") ";
    break;
  case lAUTO:
    unreachable();
  }
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
